/*
 * Copyright (C) 2004 Nuno Sousa
 * Some menu code based on menu.c by Bernard Leach
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <math.h>
#include <string.h>
#include <errno.h>

#include "pz.h"

#include "init.h"
#include "functions.h"
#include "dopewars.h"

static PzModule *module;
static PzWidget *wid;
static PzWindow *ret;

//static ttk_surface srf;
static int w, h;
static int fload=0, confirm=0;
TSheet event_sheet;

void check_over(ttk_surface srf);

static void idw_draw_sheet(ttk_surface srf, TSheet *sheet) {
  //GR_SIZE width, height, base;
  int width, height;
  char str[50], *ap;
  int i;
	
	if (sheet == NULL) {
    sheet = game.screen->menuitems[game.select].sheet;
  }
	
	// draw the title
  //pz_draw_header (sheet->title);
  ttk_window_set_title(ret, sheet->title);

  //GrGetGCTextSize(idw_gc, sheet->button, -1, GR_TFASCII, &width, &height, &base);
  height = ttk_text_height(ttk_textfont) + 4;  
  width = ttk_text_width(ttk_textfont, sheet->button);
  
  
  // (left, top, right, bottom)
  //GrSetGCForeground(idw_gc, BLACK);
  //GrLine(idw_wid, idw_gc, 20, 0, 20, screen_info.rows-44);
  ttk_line(srf, 20, 0, 20, ttk_screen->h-44, ttk_makecol(BLACK));
  //GrLine(idw_wid, idw_gc, 20, screen_info.rows-44, screen_info.cols-20, screen_info.rows-44);
  ttk_line(srf, 20, ttk_screen->h-44, ttk_screen->w-20, ttk_screen->h-44, ttk_makecol(BLACK));
  //GrLine(idw_wid, idw_gc, screen_info.cols-20, 0, screen_info.cols-20, screen_info.rows-44);
  ttk_line(srf, ttk_screen->w-20, 0, ttk_screen->w-20, ttk_screen->h-44, ttk_makecol(BLACK));
  
	//GrSetGCForeground(idw_gc, WHITE);
  //GrFillRect(idw_wid, idw_gc, 21, 0, screen_info.cols-41, screen_info.rows-44);
  //ttk_fillrect(srf, 21, 0, ttk_screen->w-41, ttk_screen->h-44, ttk_ap_getx("menu.selfg")->color);//was white
  ttk_ap_fillrect (srf, ttk_ap_getx ("menu.selbg"), 0, 0, ttk_screen->w, ttk_screen->h);
	//GrSetGCForeground(idw_gc, BLACK);
  //GrSetGCUseBackground(idw_gc, GR_FALSE);
  //GrSetGCMode(idw_gc, GR_MODE_SET);
  
  ap = strtok(sheet->text, "\n");
  for (i=0; ap != NULL; i++) {
    //GrText(idw_wid, idw_gc, 30, 1 + ((i + 1) * height - 4), ap, -1, GR_TFASCII);
    ttk_text(srf, ttk_menufont, 30, 1 + ((i + 1) * height - 4), ttk_ap_getx("menu.selfg")->color, ap);//was black
    ap = strtok(NULL, "\n");
  }
  
	if (sheet->ammount != -1)
	{
    // print ammount
    sprintf(str, "Ammount: %d", game.ammount);
    //GrText(idw_wid, idw_gc, 30, 50, str, -1, GR_TFASCII);
    ttk_text(srf, ttk_menufont, 30, 50, ttk_ap_getx("menu.selfg")->color, str);//was black
  } else {
    // the next time the user presses the middle button the sheet will disappear
    game.dismiss_sheet = 1;
  }

  // print the single menu option
  //GrSetGCForeground(idw_gc, BLACK);
  //GrFillRect(idw_wid, idw_gc, 21, 1 + 4 * height-4, screen_info.cols-41, height-1);
  //ttk_fillrect(srf, 21, 1 + 4 * height-4, ttk_screen->w-41, height-1, ttk_makecol(BLACK));
  //GrSetGCForeground(idw_gc, WHITE);
  //GrSetGCUseBackground(idw_gc, GR_TRUE);

  //GrText(idw_wid, idw_gc, (screen_info.cols/2)-width+4, (5 * height - 8), sheet->button, -1, GR_TFASCII);
  ttk_text(srf, ttk_menufont, (ttk_screen->w/2)-width+4, (5 * height - 8), ttk_ap_getx("menu.selfg")->color, sheet->button);//was black

  // we're in a transaction
  game.in_transaction = 1;  
}

static void idw_draw_screen(ttk_surface srf) 
{
  int i, dif=0, max=0;
  int width, height;
  	
	// This white line is printed because the sheet leaves two pixels
  //GrSetGCForeground(idw_gc, WHITE);
  //GrLine(idw_wid, idw_gc, 0, 0, screen_info.cols, 0);
  ttk_line(srf, 0, 0, ttk_screen->w, 0, ttk_makecol(WHITE));
  //GrSetGCForeground(idw_gc, BLACK);
	
	// calculate the biggest space you can leave for the right-side column
	for (i=0; i < game.screen->count; i++)
	{
	  //GrGetGCTextSize(idw_gc, game.screen->menuitems[i].value, -1, GR_TFASCII, &width, &height, &base);
    //width+=5;
    width = ttk_text_width(ttk_textfont, game.screen->menuitems[i].value) + 5;
    
    if (width > max) max = width;
	}

  //GrGetGCTextSize(idw_gc, "M", -1, GR_TFASCII, &width, &height, &base);
	//height += 4;
	height = ttk_text_height(ttk_textfont) + 4;

  
  // print all the menus
  for (i=0; i < game.screen->count; i++)
  {
    if ((game.select == i) && (game.screen->menuitems[i].sheet)) {
			//GrSetGCForeground(idw_gc, BLACK);
			//GrFillRect(idw_wid, idw_gc, 0, 1 + i * height, screen_info.cols, height);
			//ttk_fillrect(srf, 0, 1 + i * height, ttk_screen->w, height, ttk_makecol(BLACK));
			//GrSetGCForeground(idw_gc, WHITE);
			//GrSetGCUseBackground(idw_gc, GR_TRUE);
			confirm=1;
		} else
		{
			//GrSetGCUseBackground(idw_gc, GR_FALSE);
			//GrSetGCForeground(idw_gc, WHITE);
			//GrFillRect(idw_wid, idw_gc, 0, 1 + i * height, screen_info.cols, height);
			//ttk_fillrect(srf, 0, 1 + i * height, ttk_screen->w, height, ttk_makecol(WHITE));
			//^^THAT WAS COMMENTED OUT!
			//GrSetGCForeground(idw_gc, BLACK);
			confirm=2;
		}
		
		// highlite drug's name if you can make a positive sale
		if ((game.screen == &sell) && (game.drugs[i])) {
      dif = (game.price[i]*game.drugs[i] - game.old_price[i]);
    
      if (dif > 0) {
        //GrText(idw_wid, idw_gc, 9, 1 + ((i + 1) * height - 4), game.screen->menuitems[i].caption, -1, GR_TFASCII);
        if(confirm == 1) {
        	 ttk_ap_fillrect (srf, ttk_ap_getx ("menu.selbg"), 0, (1 + ((i + 1) * height - 4))-2, ttk_screen->w, (1 + ((i + 1) * height - 4))+((height-4)+2));
        	 ttk_text(srf, ttk_menufont, 9, 1 + ((i + 1) * height - 4), ttk_ap_getx("menu.selfg")->color, game.screen->menuitems[i].caption);//was white
        }
        else if(confirm == 2)
        	 ttk_text(srf, ttk_menufont, 9, 1 + ((i + 1) * height - 4), ttk_ap_getx("menu.fg")->color, game.screen->menuitems[i].caption);//was black
      }
    }
    
    //GrText(idw_wid, idw_gc, 8, 1 + ((i + 1) * height - 4), game.screen->menuitems[i].caption, -1, GR_TFASCII);
    //ttk_text(srf, ttk_menufont, 8, 1 + ((i + 1) * height - 4), ttk_makecol(WHITE), game.screen->menuitems[i].caption);
    if(confirm == 1) {
    	ttk_ap_fillrect (srf, ttk_ap_getx ("menu.selbg"), 0, (1 + ((i + 1) * height - 4))-2, ttk_screen->w, (1 + ((i + 1) * height - 4))+((height-4)+2));
      ttk_text(srf, ttk_menufont, 8, 1 + ((i + 1) * height - 4), ttk_ap_getx("menu.selfg")->color, game.screen->menuitems[i].caption);//was white
      ttk_text(srf, ttk_menufont, ttk_screen->w - max, 1 + ((i + 1) * height - 4), ttk_ap_getx("menu.selfg")->color, game.screen->menuitems[i].value);
    }
    else if(confirm == 2) {
    	ttk_text(srf, ttk_menufont, 8, 1 + ((i + 1) * height - 4), ttk_ap_getx("menu.fg")->color, game.screen->menuitems[i].caption);//was black
      ttk_text(srf, ttk_menufont, ttk_screen->w - max, 1 + ((i + 1) * height - 4), ttk_ap_getx("menu.fg")->color, game.screen->menuitems[i].value);
    }
    
    // right-side column
    //GrText(idw_wid, idw_gc, screen_info.cols - max, 1 + ((i + 1) * height - 4), game.screen->menuitems[i].value, -1, GR_TFASCII);
    //ttk_text(srf, ttk_menufont, ttk_screen->w - max, 1 + ((i + 1) * height - 4), ttk_makecol(BLACK), game.screen->menuitems[i].value);
    // ^^ MOVED ABOVE TO MAKE IT SIMPLE
    confirm=0;
  }
}

static void idw_do_draw(PzWidget *wid, ttk_surface srf)
{
  char header[50];
	
	//ttk_fillrect (srf, 0, 0, ttk_screen->w, ttk_screen->h, ttk_ap_getx("menu.bg")->color);
	ttk_ap_fillrect (srf, ttk_ap_getx ("menu.bg"), 0, 0, ttk_screen->w, ttk_screen->h);
  if(fload==0)
  {
    snprintf(header, sizeof(header), "DopeWars - %s", game.screen->title);
    //pz_draw_header (header);
    ttk_window_set_title(wid->win, header);
  
    // validate the selected menu
    if (!game.screen->menuitems[game.select].sheet) 
    {
      for (; (!game.screen->menuitems[game.select].sheet) && (game.select < game.screen->count); game.select++);
    }
  
    idw_draw_screen(srf);
  }
  else if(fload==1)
  {
  	check_over(srf);
  	fload=0;
  }
  else if(fload==2)
  {
  	idw_draw_sheet(srf, NULL);
  	fload=0;
  }
  else if(fload==3)
  {
  	idw_draw_sheet(srf, &event_sheet);
  	fload=0;
  }
}

void check_over(ttk_surface srf)
{
  char str[50];
  TSheet gameover_sheet;

  if (game.days == game.max_days)
  {
    // game over
    strcpy(gameover_sheet.title, "Game Over!");
    if (game.debt) {
      strcpy(str, "You didn't pay off your\ndebt!\nYou lose.");
    } else {
      sprintf(str, "You finished with $%d.", game.money + game.bank - game.debt);
    }
    strcpy(gameover_sheet.text, str);
    strcpy(gameover_sheet.button, "Again!");
    gameover_sheet.ammount = -1;

    idw_draw_sheet(srf, &gameover_sheet);
  }

  if (! game.life)
  {
    // game over
    strcpy(gameover_sheet.title, "Game Over!");
    sprintf(str, "You died.\nYou finished with $%d.", game.money + game.bank - game.debt);
    strcpy(gameover_sheet.text, str);
    strcpy(gameover_sheet.button, "Again!");
    gameover_sheet.ammount = -1;

    idw_draw_sheet(srf, &gameover_sheet);
  }
}

static int idw_do_keystroke(PzEvent *e)
{
   int ret = TTK_EV_CLICK;
   //TSheet event_sheet;
   int n;
   
   if ( game.dismiss_sheet ) {
   	 if (e->type == PZ_BUTTON_ACTION) {
   	 	 if (game.days == game.max_days) restart();
      
       game.dismiss_sheet = 0;
       game.in_transaction = 0;
       //idw_do_draw();
       wid->dirty++;
     }
    
     return 1;
   }
   
   switch (e->type) {
   	case PZ_EVENT_SCROLL:
     TTK_SCROLLMOD( e->arg, 5);
      if( e->arg > 0){
      	if (game.in_transaction) {
        if (game.ammount < game.screen->menuitems[game.select].sheet->ammount) game.ammount++;
        init_sheets();
        //idw_draw_sheet(NULL);
        fload=2;
        wid->dirty++;
        break;
      }
      if (game.select >= game.screen->count-1) break;
      
      game.select++;
      //idw_do_draw();}
      wid->dirty++;}
     else {if (game.in_transaction) {
        if (game.ammount) game.ammount--;
        init_sheets();
        //idw_draw_sheet(NULL);
        fload=2;
        wid->dirty++;
        break;
      }
      if (game.select <= 0) break;
      
      game.select--;
      //idw_do_draw();}
      wid->dirty++;}
      
       break;
       
       case PZ_EVENT_BUTTON_DOWN:
       switch (e->arg) {
       	
    case PZ_BUTTON_ACTION: /* Wheel button */
      if (! game.screen->menuitems[game.select].sheet) break;
      if ( (game.screen == &buy) && (!afford(game.select)) ) break;
      if ( (game.screen == &sell) && (!game.drugs[game.select]) ) break;
      if ( (game.screen->menuitems[game.select].sheet == &borrow_sheet) && (!game.debt) ) break;
      if ( (game.screen->menuitems[game.select].sheet == &withdraw_sheet) && (!game.bank) ) break;

      init_sheets();
      if (! game.in_transaction ) {
        // set initial ammount value to be shown on the sheet
        game.ammount = game.screen->menuitems[game.select].sheet->ammount;
        init_sheets();
      }
      init_screens();
     
      if ( game.screen == &jet ) {
        if (game.city == game.select) break;
        
        travel();

        // let's get a random event (high-low)+low
        n = (rand() % EVENT_COUNT);

        // it has a 50-50 chance of occurring
        if (! (rand() % 2)) {
          event_sheet = random_event(n);
          //idw_draw_sheet(&event_sheet);
          fload=3;
          wid->dirty++;
          init_screens();
        } else {
          init_screens();
          //idw_do_draw();
          wid->dirty++;
        }
        
        //check_over();
        fload=1;
        wid->dirty++;
        break;
      }
            
      if ( game.in_transaction ) {
        // we're going to buy/sell
        if (game.screen == &buy) do_buy(game.select, game.ammount);
        if (game.screen == &sell) do_sell(game.select, game.ammount);
        if (game.screen->menuitems[game.select].sheet == &deposit_sheet) do_deposit();
        if (game.screen->menuitems[game.select].sheet == &withdraw_sheet) do_withdraw();
        if (game.screen->menuitems[game.select].sheet == &pay_sheet) do_pay();
        if (game.screen->menuitems[game.select].sheet == &borrow_sheet) do_borrow();
        
        // transaction finished
        game.in_transaction = 0;
        init_screens();
        //idw_do_draw();
        wid->dirty++;
        break;
      }
      
      //idw_draw_sheet(NULL);
      fload=2;
      wid->dirty++;
      break;
      
    case PZ_BUTTON_PLAY: /* Play/pause button */
      break;
      
    case PZ_BUTTON_PREVIOUS: /* Rewind button */
      if (game.in_transaction) break;
      if (!game.screen->prev) break;
      
      game.screen = game.screen->prev;
      game.select=0;
      //idw_do_draw();
      wid->dirty++;
      break;
      
    case PZ_BUTTON_NEXT: /* Fast forward button */
      if (game.in_transaction) break;
      if (!game.screen->next) break;
      
      game.screen = game.screen->next;
      game.select=0;
      //idw_do_draw();
      wid->dirty++;
      break;
      
    case PZ_BUTTON_MENU: /* Menu button */
      //if (game.in_transaction) {
        // cancel transaction
     //   game.in_transaction = 0;
    //    game.ammount = 0;
    //    idw_do_draw();
    //    break;
   //   }
  //    pz_close_window (idw_wid);
    //  GrDestroyGC(idw_gc);
   //   break;
   // default:
        pz_close_window(e->wid->win);
        break;}
   }
   return ret;
}

static PzWindow *new_idw_window()
{
     PzWindow *ret;
   
     w =ttk_screen->w;
     h =ttk_screen->h;

    ret = pz_new_window ("Dopewars", PZ_WINDOW_NORMAL);
    
    wid = pz_add_widget(ret, idw_do_draw, idw_do_keystroke);
    
    init_defaults();
    init_drugs();
	  init_screens();
	  init_sheets();

     pz_widget_set_timer(wid, 150);
    return pz_finish_window (ret);
}

static void init_idw()
{
    module = pz_register_module ("dopewars", NULL);
    pz_menu_add_action ("/Extras/Games/Dopewars", new_idw_window);
   
}

PZ_MOD_INIT(init_idw)
